siApp
.directive('siGravityFormModule', function(){
    return {
        restrict: 'E',
        link: function($scope,$element,$attrs){
            $scope.init($attrs.formId);
        },
        controller: function($scope,$element, $siHooks){
            $scope._form_initialized = false;
            $scope.form_id = 0;

            $scope.init = function($form_id){
                console.log('siGravityFormModule init');
                $scope.form_id = $form_id;

                $siHooks.addAction('si-modal-open', function(){
                    $scope.initForm();
                    $scope.resetForm();
                });

                $siHooks.addAction('listing-message-model-post-process', function($model){
                    $scope.fillForm($model);
                })

            }

            $scope.initForm = function(){
                if($scope._form_initialized) return;

                // jQuery(document).ready(function(){
                //     console.log('re-init gform');
                //     // var current_page = jQuery('#gform_source_page_number_' + $scope.form_id).val();
                //     // console.log(current_page);
                    
                //     //gformInitSpinner( $form_id, '{$spinner_url}' );
                //     //jQuery('#gform_ajax_frame_' + $scope.form_id).trigger('load');
                //     //jQuery(document).trigger('gform_page_loaded', [$scope.form_id, 1]);
                //     //jQuery(document).trigger('gform_post_render', [$scope.form_id, 1]);
                //     $scope._form_initialized = true;
                // });
            }

            $scope.fillForm = function($model){
                console.log('fill g-form')
                let field = $scope.getSubjectField();
                if(field == null) field = $scope.getMessageField();
                if(field == null) return;

                const targetField = $scope.getTargetField();
                if(targetField != null) { 
                    console.log('set target email', $model.targets);
                    targetField.value = $model.targets.join(',');
                }

                console.log('setting value on', field, $model.subject);
                field.value = $model.subject;
            }

            $scope.getSubjectField = function(){
                return $scope.findFields([
                    'subject','title','object',
                    'sujet','titre','objet'
                ]);
            }

            $scope.getMessageField = function(){
                return $scope.findFields([
                    'message','text',
                    'texte','comment'
                ]);
            }

            $scope.getTargetField = function() {
                return $scope.findFields(['destinataire','target']);
            }


            $scope.findFields = function($labels){
                const lFoundFields = [];
                
                Array.from($element[0].querySelectorAll('.gfield_label')).forEach( labelElm => {
                    const labelText = labelElm.innerHTML.toLowerCase();
                    
                    if($labels.some(l => labelText.includes(l))){
                        const input = $element[0].querySelector(`#${labelElm.getAttribute('for')}`);
                        if(input != null) {
                            console.log(labelText, 'input found');
                            lFoundFields.push(input);
                        }
                    }
                });

                if(lFoundFields.length>0){                    
                    return lFoundFields[0];
                }

                return null;
            }

            $scope.resetForm = function(){
                // jQuery( 'div.wpcf7 > form' ).each( function() {
                //     var $form = jQuery( this );
                //     wpcf7.clearResponse($form)
                // });
            }
            
        }
    }
})