<div class="si-main-filter-tabs si-tab-count-{{configs.search_engine_options.tabs.length}}"
        ng-if="configs.search_engine_options.tabbed">
    <div ng-repeat="tab in configs.search_engine_options.tabs track by $index"
            class="si-tab {{configs.current_view == tab.view_id ? 'active' : ''}}"
            ng-click="selectView(tab.view_id)"
            >
            {{tab.caption | translate}}
    </div>

    <div class="si-dropdown" data-show-button-icon="false">
        <div class="si-dropdown-button"><si-icon>ellipsis-h</si-icon></div>
        <div class="si-dropdown-panel">
            <div class="si-dropdown-item {{configs.current_view == tab.view_id ? 'active' : ''}}" 
                    ng-repeat="tab in configs.search_engine_options.tabs track by $index"
                    ng-click="selectView(tab.view_id)">
                    {{tab.caption | translate}}</div>
        </div>
    </div>
    
</div>

<div class="si-inputs {{(!isFieldFiltered('searchbox')) ? 'no-searchbox' : ''}}" >
    <div class="si-search-box" ng-if="isFieldFiltered('searchbox')" >
        <si-search-box
            alias="<?php echo $configs->alias ?>" 
            placeholder="<?php si_label('Search by first or last name') ?>"></si-search-box>

    </div>
    
    <div class="si-panel-button  si-element-padding-block-sm si-element-padding cities {{isExpanded('cities')}} {{filter.hasFilter(['location_countries','location_states','location_regions','location_cities']) ? 'si-has-filters' : ''}}"  
        ng-click="toggleExpand($event,'cities')"
        ng-if="isFieldFiltered('cities')"><span><?php si_label('Cities') ?></span> <si-icon>angle-down</si-icon></div>

    <div class="si-panel-button  si-element-padding-block-sm si-element-padding letters {{isExpanded('letters')}} {{filter.hasFilter('letters') ? 'si-has-filters' : ''}}"  
        ng-click="toggleExpand($event,'letters')"
        ng-if="isFieldFiltered('letters')"><span><?php si_label('Letter') ?></span> <si-icon>angle-down</si-icon></div>
    <div class="si-panel-button  si-element-padding-block-sm si-element-padding offices {{isExpanded('offices')}} {{filter.hasFilter('offices') ? 'si-has-filters' : ''}}" 
        ng-if="officeList.length > 1 && isFieldFiltered('offices')"
         ng-click="toggleExpand($event,'offices')"><span><?php si_label('Offices') ?></span> <si-icon>angle-down</si-icon></div>

    <div class="si-panel-button  si-element-padding-block-sm si-element-padding more-button {{isExpanded('others')}} 
        {{ filter.hasFilter(getOtherPanelFilterList()) ? 'si-has-filters' : '' }}"
        ng-click="toggleExpand($event,'others')"><si-icon>ellipsis-h</si-icon></div>

</div>

<div class="si-search-action">    
    <button type="button" class="reset-button si-button" data-ng-show="filter.hasFilters()" data-ng-click="resetFilters()" title="<?php si_label('Reset') ?>"><si-icon>undo</si-icon></button>
    <button type="button" class="trigger-button si-button" data-ng-show="result_url != null" data-ng-click="showResultPage()" title="<?php si_label('Search') ?>"><si-icon>search</si-icon></button>
        

    <div class="si-filter-menu">
        <div class="si-dropdown" data-show-button-icon="false">
            <div class="si-dropdown-button si-element {{filter.hasFilters() ? 'active' : ''}}"> <span class="label"><?php si_label("Filters") ?></span> <span><si-icon>filter</si-icon><b ng-if="filter.hasFilters()">{{filter.count()}}</b></span></div>
            <div class="si-dropdown-panel">
                <div class="si-dropdown-item {{filter.hasFilter('cities') ? 'has-filters' : ''}}" ng-click="toggleExpand($event,'cities')"><?php si_label('Cities') ?></div>
                <div class="si-dropdown-item {{filter.hasFilter('letters') ? 'has-filters' : ''}}" ng-click="toggleExpand($event,'letters')"><?php si_label('Letter') ?></div>
                <div class="si-dropdown-item {{filter.hasFilter('licenses') ? 'has-filters' : ''}}" ng-click="toggleExpand($event,'licenses')"><?php si_label('Licenses') ?></div>
                <div class="si-dropdown-item {{filter.hasFilter('offices') ? 'has-filters' : ''}}" ng-click="toggleExpand($event,'offices')"><?php si_label('Offices') ?></div>
            </div>
        </div>
    </div>
</div>

<!-- LETTERS -->
<?php
SourceImmo::view("list/brokers/search/panels/cities");
?>

<!-- LETTERS -->
<?php
SourceImmo::view("list/brokers/search/panels/letters");
?>


<!-- LICENSES -->
<?php
SourceImmo::view("list/brokers/search/panels/licenses");
?>


<!-- OFFICES -->
<?php
SourceImmo::view("list/brokers/search/panels/offices");
?>

<!-- OTHER -->
<?php
SourceImmo::view("list/brokers/search/panels/other");