<?php 
//Debug::write($configs);
extract( shortcode_atts(
    array(
        'side_scroll' => false
    ), $sc_atts )
);
unset($sc_atts['side_scroll']);

$global_container_classes = array('si', 'si-category-mosaic-layout');
$global_container_attr = array();

global $dictionary;


$meta = SourceImmoApi::get_list_meta($configs);


$dictionary = new SourceImmoDictionary($meta->dictionary);

$list_styles = array();
$list_attrs = [];

$list = [];

//__c($presets);


foreach($dictionary->entries->listing_subcategory as $key => $subcategory){
    
    
    $filter = base64_encode(json_encode(
        ["subcategories" => [$key]]
    ));
    $key = sanitize_title($key);
    $counterIndex = array_search('listing', $subcategory->src);

    $item = (object) array(
        "subcategory_code" => $key,
        "subcategory" => $subcategory->caption,
        "permalink" => $target . '?si-search=' . urlencode($filter),
        "photo_url" => 'https://picsum.photos/640?random=' . rand(1, 1000) . '&category=' . $subcategory->caption,
        "listings" => isset($subcategory->src_count) ? $subcategory->src_count[$counterIndex] : ''
    );
    if(isset($presets->{$key})){
        $preset = $presets->{$key};
        // Get a random image from the preset
        $randIndex = rand(0, count($preset->images) - 1);
        $item->photo_url = SI_PLUGIN_URL . $preset->images[$randIndex]->url;
        $item->photo_credits = $preset->images[$randIndex]->credits;
    }

    $list[] = $item;
    if(count($list) >= $limit){
        break;
    }
}

$global_container_classes[] = 'si-mosaic-of-' . count($list);

?>
<div class="<?php echo(implode(' ' , $global_container_classes)) ?>" 
    style="<?php echo(implode(';', $list_styles)) ?>"  
    <?php echo(implode(' ', $list_attrs)) ?>
    si-lazy-load>
    <?php

    if(count($list) > 0){
        

        echo('<div class="si-list">');
            $itemIndex = 0;
            foreach ($list as $item) {
                
                echo('<div class="si-category-item si-item-' . $item->subcategory_code . '" style="--si-item-index:' . $itemIndex . '">');
                    SourceImmo::view("list/{$configs->type}/direct/item-category", 
                    array("configs" => $configs, "item" => $item, "dictionary"=> $dictionary));
                echo('</div>');

                $itemIndex++;
            }

            if($showAllLabel != null && $target != ''){
                echo('<div class="si-category-item si-item-all" style="--si-item-index:' . $itemIndex . '"><div class="si-item-content"><a href="' . $target . '"><span>' . $showAllLabel . '</span></a></div></div>');
            }
        
        echo('</div>');
    }
    ?>
</div>