    <div class="si-main-filter-tabs si-tab-count-{{configs.search_engine_options.tabs.length}}" ng-if="configs.search_engine_options.tabbed">
        <div ng-repeat="tab in configs.search_engine_options.tabs track by $index"
                class="si-tab {{configs.current_view == tab.view_id ? 'si-active' : ''}}"
                ng-click="selectView(tab.view_id)"
                >
                {{tab.caption | translate}}
        </div>

        <div class="si-dropdown" data-show-button-icon="false">
            <div class="si-dropdown-button"><si-icon>ellipsis-h</si-icon></div>
            <div class="si-dropdown-panel">
                <div class="si-dropdown-item {{configs.current_view == tab.view_id ? 'active' : ''}}" 
                        ng-repeat="tab in configs.search_engine_options.tabs track by $index"
                        ng-click="selectView(tab.view_id)">
                        {{tab.caption | translate}}</div>
            </div>
        </div>
        
    </div>

    <div class="si-inputs">
        <div class="si-search-box">
            
            <si-search-box 
                    alias="<?php echo $configs->alias ?>"></si-search-box>
            
            
        </div>

        <si-geo-filter si-alias="<?php echo $configs->alias ?>"></si-geo-filter>

        <div class="si-panel-button si-hover-shade si-element-padding-block-sm si-element-padding cities-button {{isExpanded('cities')}} {{filter.hasFilter(['regions','cities','location_countries','location_states','location_regions','location_cities']) ? 'si-has-filters' : ''}}"  
                ng-if="allowPanel('cities')"
                ng-click="toggleExpand($event,'cities')"><span si-pluralize="{on:'dictionary/city', label:'<?php si_label('Cities') ?>'}"><?php si_label('City') ?></span> <si-icon>angle-down</si-icon></div>
    
        <div class="si-panel-button si-hover-shade si-element-padding-block-sm si-element-padding price-button {{isExpanded('price')}} {{filter.hasFilter(['min_price','max_price']) ? 'si-has-filters' : ''}}"  
                ng-if="allowPanel('price')"
                ng-click="toggleExpand($event,'price')"><span><?php si_label('Price') ?></span> <si-icon>angle-down</si-icon></div>
    
        <div class="si-panel-button si-hover-shade si-element-padding-block-sm si-element-padding category-button {{isExpanded('categories')}} {{filter.hasFilter(['categories','building_categories','subcategories']) ? 'si-has-filters' : ''}}"  
                ng-if="allowPanel('categories')"
                ng-click="toggleExpand($event,'categories')"><span si-pluralize="{on:['dictionary/listing_subcategory','dictionary/building_category'], label:'<?php si_label('Types') ?>'}"><?php si_label('Type') ?></span> <si-icon>angle-down</si-icon></div>
        
        
        <div class="si-panel-button si-hover-shade si-element-padding-block-sm si-element-padding areas-button {{isExpanded('areas')}} {{filter.hasFilter(['available_min','available_max','land_min','land_max']) ? 'si-has-filters' : ''}}" 
                ng-if="allowPanel('areas')"
                ng-click="toggleExpand($event,'areas')"><span><?php si_label('Areas') ?></span> <si-icon>angle-down</si-icon></div>


        <div class="si-panel-button si-hover-shade si-element-padding-block-sm si-element-padding more-button {{isExpanded('others')}} 
                {{ filter.hasFilter(getOtherPanelFilterList()) ? 'si-has-filters' : '' }}"
                ng-click="toggleExpand($event,'others')"><si-icon kit="solid">ellipsis-h</si-icon></div>
    

        
    </div>
    

    <div class="si-search-action">
        <button type="button" class="reset-button si-button" data-ng-if="filter.hasFilters()" data-ng-click="resetFilters()" title="<?php si_label('Reset') ?>"><si-icon>undo</si-icon></button>
        
        
        <div class="si-filter-menu">
            <div class="si-dropdown" data-show-button-icon="false">
                <div class="si-dropdown-button si-element {{filter.hasFilters() ? 'active' : ''}}"><span class="label"><?php si_label("Filters") ?></span> <span>
                    <si-icon>filter</si-icon> <b ng-if="filter.hasFilters()">{{filter.count()}}</b>
                </span></div>
                <div class="si-dropdown-panel">
                    <div class="si-dropdown-item {{filter.hasFilter(['regions','cities']) ? 'has-filters' : ''}}" ng-click="toggleExpand($event,'cities')"><?php si_label('Cities') ?></div>
                    <div class="si-dropdown-item {{filter.hasFilter(['min_price','max_price']) ? 'has-filters' : ''}}" ng-click="toggleExpand($event,'price')"><?php si_label('Price') ?></div>
                    <div class="si-dropdown-item {{filter.hasFilter(['categories','subcategories']) ? 'has-filters' : ''}}" ng-click="toggleExpand($event,'categories')"><?php si_label('Home types') ?></div>
                    <div class="si-dropdown-item 
                        {{filter.hasFilter(getOtherPanelFilterList()) ? 'has-filters' : '' }}" 
                        ng-click="toggleExpand($event,'others')"><?php si_label('More') ?></div>

                    <div class="si-dropdown-item reset-option" ng-if="filter.hasFilters()" ng-click="resetFilters()"><?php si_label('Reset filters') ?></div>
                </div>
            </div>
        </div>
        
        <button type="button" class="trigger-button si-button" data-ng-if="result_url != null" data-ng-click="showResultPage()" title="<?php si_label('Search') ?>">
            <span class="label"><?php si_label('Search') ?></span> 
            <si-icon>search</si-icon>
        </button>
    </div>

    <?php
    if($configs->search_engine_options->filter_tags == 'inside'){
        echo('<si-search-filter-tags si-alias="' . $configs->alias . '"></si-search-filter-tags>');
    }
    ?>


    <!-- Cities -->
    <?php
    SourceImmo::view("list/listings/search/panels/cities");
    ?>

    

    
    <!-- Category -->
    <?php
    SourceImmo::view("list/listings/search/panels/categories");
    ?>


    
    <!-- Price -->
    <?php
    SourceImmo::view("list/listings/search/panels/price");
    ?>

    <!-- Areas -->
    <?php
    SourceImmo::view("list/listings/search/panels/areas");
    ?>
    

    <!-- Mores -->
    <?php
    SourceImmo::view("list/listings/search/panels/other");