<?php
$panelKey = 'categories';
?>

    <div class="si-filter-panel categories-panel {{isExpanded('<?php echo($panelKey) ?>')}} ">
        <div class="si-filter-panel-header">
            <div  class="si-panel-header-title"><?php si_label('Types') ?></div>
            <button class="si-button" type="button"  ng-click="toggleExpand($event,'<?php echo($panelKey) ?>')"><si-icon>xmark</si-icon></button>
        </div>
        
        <div class="si-filter-panel-content" >


            <div class="listing-subcategory si-panel-list">
                <h4 si-pluralize="{on:'dictionary/listing_subcategory', label:'<?php si_label('Property types') ?>'}"><?php si_label('Property type') ?></h4>
                
                <div class="si-list-container subcategories" ng-if="subcategory_list.length <= 15">
                    <si-checkbox
                        data-ng-repeat="item in subcategory_list | orderBy: 'caption'"
                        data-si-value="{{item.__$key}}"
                        data-ng-model="filter.data.subcategories"
                        si-change="filter.update()"
                        data-label="{{item.caption}}"
                                ></si-checkbox>
                </div>

                <div class="si-list-container categories" ng-if="subcategory_list.length > 15">
                    <div class="si-list-item category {{filter.sublistHasFilters(category.__$obj_key, subcategory_list, filter.data.categories) ? 'has-filters' : ''}}" 
                        data-ng-repeat="category in category_list | orderObjectBy: 'caption'" 
                        >

                        <div class="si-list-item-title category-name {{category.expanded ? 'expanded' : ''}}">
                            <si-checkbox 
                                data-ng-model="filter.data.categories"
                                data-si-change="filter.update()"
                                data-si-value="{{category.__$obj_key}}"
                                ></si-checkbox> 
                            <div class="si-title-label" data-ng-click="expandSublist(category_list,category)"
                                data-ng-click-off="changeRegionTab(category.__$obj_key)"><span>{{category.caption}}</span> <si-icon>plus</si-icon></div>                                
                        </div>

                        <div class="si-sublist category-subcategories {{category.expanded ? 'expanded' : ''}}" 
                            style="--item-count:{{(subcategory_list | filter : {parent: category.__$obj_key}).length}}">

                            <div>
                                <div class="si-sublist-container subcategory-container">
                                    <si-checkbox
                                        data-ng-repeat="item in subcategory_list | filter: {parent: category.__$obj_key} | orderBy: 'caption'"
                                        data-si-value="{{item.__$key}}"
                                        data-ng-model="filter.data.subcategories"
                                        si-change="filter.update()"
                                        data-label="{{item.caption}}"
                                                ></si-checkbox>
                                </div>  
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="building-category si-panel-list" ng-show="dictionary.building_category!=undefined" ng-if="!isMainFiltered(['commercial'])">
                <h4  si-pluralize="{on:'dictionary/building_category', label:'<?php si_label('Building types') ?>'}"><?php si_label('Building type') ?></h4>
                
                <div class="si-list-container">
                    <si-checkbox
                        data-ng-repeat="(key,item) in dictionary.building_category"
                        data-si-value="{{key}}"
                        data-ng-model="filter.data.building_categories"
                        si-change="filter.update()"
                        data-label="{{item.caption.siTranslate()}}"
                        ></si-checkbox>
                </div>
            </div>
        </div>

        <div class="si-filter-panel-actions">
        <?php include '_actions.php'; ?>
        </div>
    </div>