<?php
$panelKey = 'price';
?>

<div class="si-filter-panel price-panel {{isExpanded('<?php echo($panelKey) ?>')}}">
        <div class="si-filter-panel-header">
            <div  class="si-panel-header-title"><?php si_label('Price') ?></div>
            <button class="si-button" type="button"  ng-click="toggleExpand($event,'<?php echo($panelKey) ?>')"><si-icon>xmark</si-icon></button>
        </div>
    
        <div class="si-filter-panel-content">
            <si-price-range-selector-no model="priceRange" on-change="updatePrice()" ></si-price-range-selector-no>

            <div class="si-price-inputs" >
                <div class="si-price-target">
                    <em><?php si_label('Target price') ?></em>
                    <div class="si-price-value">{{getTargetPriceLabel('<?php si_label('None') ?>')}}</div>
                    <div class="si-price-variation" ng-if="false && priceRangeRatio != ''"><si-icon>plus-minus</si-icon>{{priceRangeRatio}}<si-icon>percent</si-icon></div>
                </div>

                <div class="si-price-slider-container">
                    <si-price-range-slider 
                        model="priceRange" on-change="updatePrice()" 
                        start-label="Min" 
                        end-label="<?php si_label('Unlimited') ?>"
                        ></si-price-range-slider>

                    <div class="si-price-scale-container">
                        <div class="si-price-scale">
                            {{getPriceFromRatio(0.125)}}
                        </div>
                    </div>
                </div>

                

                <div class="si-price-input-labels"  >
                    <div class="si-price-min">
                        <em><?php si_label('Minimum') ?></em>
                        <div class="si-price-value">{{getMinPriceLabel('<?php si_label('Min') ?>')}}</div>
                        
                    </div>
                    
                    <si-icon class="si-price-divider">arrow-left</si-icon>
                    
                    <si-icon class="si-price-divider">arrow-right</si-icon>

                    <div class="si-price-max">
                        <em><?php si_label('Maximum') ?></em>
                        <div class="si-price-value">{{getMaxPriceLabel('<?php si_label('Unlimited') ?>')}}</div>
                        
                    </div>
                </div>

                <div class="si-price-range-modifier {{ (priceRange[0]!=0 || priceRange[1] != 1) ? 'si-active' : '' }}">
                        

                        <div class="si-modifier-button-container">
                            <div class="si-modifier-buttons">
                                <si-icon class="si-minus" ng-click="decreasePriceScale()">minus</si-icon>
                                <div class="si-modifier-graph scale-at-{{price_range_scale_index+1}}">
                                    <div style="--si-item-index:1" ng-click="setPriceScale(0)"></div>
                                    <div style="--si-item-index:2" ng-click="setPriceScale(1)"></div>
                                    <div style="--si-item-index:3" ng-click="setPriceScale(2)"></div>
                                    <div style="--si-item-index:4" ng-click="setPriceScale(3)"></div>
                                    <div style="--si-item-index:5" ng-click="setPriceScale(4)"></div>
                                    <div style="--si-item-index:6" ng-click="setPriceScale(5)"></div>
                                    <div style="--si-item-index:7" ng-click="setPriceScale(6)"></div>                            
                                </div>
                                <si-icon class="si-plus" ng-click="increasePriceScale()">plus</si-icon>
                            </div>
                            
                            <em><?php si_label("Change price's scale") ?></em>
                            
                        </div>
                </div>
            </div>
        </div>

        <div class="si-filter-panel-actions">
        <?php include '_actions.php'; ?>
        </div>
    </div>
